{ pkgs, config, ... }:

{
  age.secrets = {
    nextcloud_db_pass = {
      file = ../../secrets/nextcloud/nextcloud_db_pass.age;
      owner = "nextcloud";
      group = "nextcloud";
    };
    nextcloud_admin_pass = {
      file = ../../secrets/nextcloud/nextcloud_admin_pass.age;
      owner = "nextcloud";
      group = "nextcloud";
    };
  };

  services.nextcloud = {
    enable = true;
    package = pkgs.nextcloud30;

    configureRedis = true;
    hostName = "nextcloud.crans.org";
    https = false;

    maxUploadSize = "4G";

    config = {
      dbtype = "pgsql";
      dbhost = "tealc.adm.crans.org";
      dbuser = "nextcloud";
      dbpassFile = config.age.secrets.nextcloud_db_pass.path;
      adminpassFile = config.age.secrets.nextcloud_admin_pass.path;
    };

    phpOptions = {
      "opcache.interned_strings_buffer" = "32";
      "opcache.memory_consumption" = "512";
    };

    appstoreEnable = true;
    extraAppsEnable = true;
  };
}
